<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2006
sirfragalot@users.sourceforge.net
**********************************************************************************/
/*****
* RESOURCEVIEW class
*
* View a single resource.
*
* $Header: /cvsroot/wikindx/wikindx3/core/resource/RESOURCEVIEW.php,v 1.36 2006/04/23 20:42:44 sirfragalot Exp $
*****/
class RESOURCEVIEW
{
// Constructor
	function RESOURCEVIEW($db, $vars)
	{
		$this->db = $db;
		$this->vars = $vars;
		include_once("core/session/SESSION.php");
		$this->session = new SESSION();
		include_once("core/messages/MESSAGES.php");
		$this->messages = new MESSAGES();
		include_once("core/messages/ERRORS.php");
		$this->errors = new ERRORS();
		include_once("core/html/MISC.php");
		include_once("core/html/HTML.php");
		$this->html = new HTML();
		include_once("core/html/TABLE.php");
		include_once("core/resource/RESOURCEABSTRACT.php");
		include_once("core/resource/RESOURCENOTE.php");
		include_once("core/resource/RESOURCECUSTOM.php");
		include_once("core/resource/RESOURCEQUOTE.php");
		include_once("core/resource/RESOURCEPARAPHRASE.php");
		include_once("core/resource/RESOURCEMUSING.php");
		include_once("core/cite/CITE.php");
		include_once("core/group/GROUP.php");
		include_once("core/keyword/KEYWORD.php");
		include_once("core/icons/LOADICONS.php");
		$this->icons = new LOADICONS();
		include_once("core/attachments/ATTACHMENTS.php");
	}
	function view($message = FALSE, $lastSolo = FALSE)
	{
		$this->session->delVar('attachMaxSize'); // Set in attachments/ATTACHMENTS:fileAttachForm().  Always clear it here.
		if($lastSolo)
			$this->vars['id'] = $this->session->getVar('sql_lastSolo');
		if(!array_key_exists('id', $this->vars) || !$this->vars['id'])
			$this->badInput($this->errors->text("inputError", "missing"));
		$this->session->setVar("sql_lastSolo", $this->vars['id']);
		$this->session->setVar("sql_lastView", 'solo');
		$row = $this->grabResource();
		$pString = $message ? $message : FALSE;
		$pString .= $this->showResource($row);
		$pString .= TABLE::tdEnd();
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$attachments = new ATTACHMENTS($this->db, $this->vars);
		$pString .= TABLE::td($attachments->attachedFiles($row['resourceId']));
		unset($attachments);
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$abstract = new RESOURCEABSTRACT($this->db, $this->vars);
		$pString .= TABLE::td($abstract->view($row));
		unset($abstract);
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$pString .= TABLE::td($this->showUrl($row));
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$note = new RESOURCENOTE($this->db, $this->vars);
		$pString .= TABLE::td($note->view($row));
		unset($note);
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$custom = new RESOURCECUSTOM($this->db, $this->vars);
		$pString .= TABLE::td($custom->view($row));
		unset($custom);
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$quote = new RESOURCEQUOTE($this->db, $this->vars);
		$pString .= TABLE::td($quote->view($this->vars['id']));
		unset($quote);
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$paraphrase = new RESOURCEPARAPHRASE($this->db, $this->vars);
		$pString .= TABLE::td($paraphrase->view($this->vars['id']));
		unset($paraphrase);
		$pString .= TABLE::trEnd();
		$pString .= TABLE::trStart();
		$pString .= TABLE::tdStart();
		$musing = new RESOURCEMUSING($this->db, $this->vars);
		$pString .= $musing->view($this->vars['id']);
		unset($musing);
// Turn on the 'add bookmark' menu item
		$this->session->setVar("bookmark_displayAdd", TRUE);
		include_once("core/template/TEMPLATE.php");
		$template = new TEMPLATE('content');
		$template->setVar('heading', $this->messages->text("heading", "resources"));
		$template->setVar('body', $pString);
		return $template->process();
	}
// Grab resource from database
	function grabResource()
	{
		include_once("core/sql/STATEMENTS.php");
		$stmt = new STATEMENTS($this->db);
// fields from WKX_resource_note, WKX_resource_category, WKX_resource_keyword and WKX_abstract:
		$array = array("text", "categories", "keywords", "abstract", "addUserIdAbstract", "editUserIdAbstract",
			"addUserIdNote", "editUserIdNote",);
		$sql = $this->db->selectNoExecute(array("WKX_resource"), array_merge($stmt->listFields(), $array),
			$stmt->selectJoin());
		$sql .= " WHERE WKX_resource.id=" . $this->db->tidyInput($this->vars['id']);
		$recordset = $this->db->query($sql);
		if(!$this->db->numRows($recordset))
			$this->badInput($this->messages->text("resources", "noResult"));
		return $this->db->fetchRow($recordset);
	}
// display bibliographic entry
	function showResource($row)
	{
		include_once("core/styles/BIBSTYLE.php");
		$bibStyle = new BIBSTYLE($this->db, "html");
		$this->icons->getIconInfo('edit');
		$editLink = $this->icons->editExists ? "imgLink" : "link";
		$this->icons->getIconInfo('delete');
		$deleteLink = $this->icons->editExists ? "imgLink" : "link";
		$edit = $delete = FALSE;
		if($this->session->getVar('setup_write'))
			$edit = MISC::a($editLink, "&nbsp;" . $this->icons->edit .
				"&nbsp;", "index.php?action=resourceEdit" . htmlentities("&id=" . $row['resourceId']));
		if(array_key_exists("search", $this->vars) && $this->vars["search"] = 'highlight')
		{
			$searchTerms = explode(",", $this->session->getVar('search_highlight'));
			foreach($searchTerms as $term)
				$patterns[] = "/($term)/i";
			$pString = $this->previousNextLinks($row['resourceId'], TRUE);
			$bibStyle->bibformat->patterns = $patterns;
		}
		else
			$pString = $this->previousNextLinks($row['resourceId'], FALSE);
		$nextDelete = $this->nextDelete ? htmlentities("&nextDelete=" . $this->nextDelete) : FALSE;
		if($this->session->getVar('setup_superadmin'))
			$delete = MISC::a($deleteLink, "&nbsp;" . $this->icons->delete .
			"&nbsp;", "index.php?action=deleteResourceConfirm" . 
			htmlentities("&resource_id=" . $row['resourceId']) . $nextDelete);
		include_once("core/file/export/BIBTEX.php");
		$bibtex = new BIBTEX($this->db, FALSE);
		$bibtex->loadArrays();
		$bibtexKey = $this->messages->text("misc", "bibtexKey") . "&nbsp;&nbsp;" . $bibtex->citeFormat($row);
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		$pString .= TABLE::td(MISC::span($this->messages->text("resourceType", $row['type']) . ":"), "hint");
		$pString .= TABLE::td(MISC::span($this->showIsbn($row)), "hint", "center");
		$pString .= TABLE::td(MISC::span($bibtexKey), "hint", "right");
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
// Encapsulating table from template
		$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		include_once("core/user/USER.php");
		$user = new USER($this->db);
		$userAddEdit = $user->displayUserAddEdit($row['addUserIdResource'], $row['editUserIdResource']);
		$pString .= TABLE::td($bibStyle->process($row) . $userAddEdit, "alternate1");
		$pString .= TABLE::td($edit . $delete, "alternate1", "right", "top");
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
// Display resource's categories
		if($row['categories'])
			$pString .= $this->showCategories($row);
// If this resource has keywords, show them
		if($row['keywords'])
			$pString .= $this->showKeywords($row);
		$pString .= $this->showCreators($row);
		if($row['publisher'])
			$pString .= $this->showPublisher($row);
		if($row['collection'])
			$pString .= $this->showCollection($row);
// See if this resource has citations or is cited itself
		$cite = new CITE($this->db, $this->vars);
		$pString .= $cite->showCitations($row['resourceId']);
		$pString .= MISC::br() . "&nbsp;" . MISC::hr() . "&nbsp;" . MISC::br();
		return $pString;
	}
// Show previous and next resource hyperlinks
	function previousNextLinks($thisId, $highlight)
	{
		$this->nextDelete = FALSE;
		if(($raw = $this->session->getVar("list_allIds")) === FALSE)
		{
			$this->nextDelete = 'NULL';
			return FALSE;
		}
// Search highlighting in force?
		$highlight = $highlight ? htmlentities("&search=highlight") : FALSE;
// type of CSS class required.
		$this->icons->getIconInfo("next");
		$this->icons->getIconInfo("previous");
		$nextClass = $this->icons->nextExists ? "imgLink" : "link";
		$previousClass = $this->icons->previousExists ? "imgLink" : "link";
		$allIds = unserialize(base64_decode($raw));
		$thisKey = array_search($thisId, $allIds);
		if($thisKey)
			$tdLeft = MISC::a($previousClass, $this->icons->previous, "index.php?action=resourceView" .
				htmlentities("&id=" . $allIds[$thisKey - 1]) . $highlight);
		else
			$tdLeft = "&nbsp;";
		if($thisKey < (sizeof($allIds) - 1))
			$tdRight = MISC::a($nextClass, $this->icons->next, "index.php?action=resourceView" .
				htmlentities("&id=" . $allIds[$thisKey + 1]) . $highlight);
		else
			$tdRight = "&nbsp;";
		$pString = TABLE::tableStart(FALSE, 0, 10, 0, "center", 0);
		$pString .= TABLE::trStart();
		$pString .= TABLE::TD($tdLeft, FALSE, "right");
		$pString .= TABLE::td($tdRight, FALSE, "left");
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		if($this->session->getVar('setup_superadmin'))
		{
			if(array_key_exists($thisKey + 1, $allIds))
				$this->nextDelete = $allIds[$thisKey + 1];
			else if(array_key_exists($thisKey - 1, $allIds))
				$this->nextDelete = $allIds[$thisKey - 1];
			else
				$this->nextDelete = 'NULL';
		}
		return $pString;
	}
// Show resource categories
	function showCategories($row)
	{
		$obj = new GROUP($this->db);
		$pString = FALSE;
		foreach(split(",", $row['categories']) as $key => $value)
			$cats[] = "'$value'";
		$condition = $this->db->formatField('id') . "=" . join(" OR " .
			$this->db->formatField('id') . "=", $cats);
		$recordset = $this->db->select(array('WKX_category'), array("id", "category"), 
			" WHERE " . $condition . " ORDER BY " . $this->db->formatField('category'));
		while($line = $this->db->loopRecordSet($recordset))
			$cArray[$line['id']] = stripslashes($line['category']);
		$title = $this->messages->text("resources", "categories");
		if(isset($cArray))
		{
			foreach($cArray as $cId => $category)
				$newArray[] = $obj->getCategoryLink($row['resourceId'], $cId, $category);
			$pString = TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
			$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
			$pString .= TABLE::trStart();
			$pString .= TABLE::td(MISC::span($title . ": " .
				join(", ", $newArray), "small"));
			$pString .= TABLE::trEnd();
			$pString .= TABLE::tableEnd();
		}
		return $pString;
	}
// Show resource keywords
	function showKeywords($row)
	{
		$keywordObj = new KEYWORD($this->db, $this->vars);
		$pString = FALSE;
		foreach(split(",", $row['keywords']) as $key => $value)
			$keywords[] = "'$value'";
		$condition = $this->db->formatField('id') . "=" . join(" OR " .
			$this->db->formatField('id') . "=", $keywords);
		$recordset = $this->db->select(array('WKX_keyword'), array("id", "keyword"), 
			" WHERE " . $condition . " ORDER BY " . $this->db->formatField('keyword'));
		while($line = $this->db->loopRecordSet($recordset))
			$keywordArray[$line['id']] = stripslashes($line['keyword']);
		$title = $this->messages->text("resources", "keywords");
		if(isset($keywordArray))
		{
			foreach($keywordArray as $keywordId => $keyword)
				$newArray[] = $keywordObj->getKeywordLink($row['resourceId'],
					$keywordId, $keyword);
			$pString = TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
			$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
			$pString .= TABLE::trStart();
			$pString .= TABLE::td(MISC::span($title . ": " .
				join(", ", $newArray), "small"));
			$pString .= TABLE::trEnd();
			$pString .= TABLE::tableEnd();
		}
		return $pString;
	}
// show resource creators
	function showCreators($row)
	{
		include_once("core/creator/CREATOR.php");
		$obj = new CREATOR($this->db);
		foreach(split(",", $row['creator1']) as $key => $value)
			$creators[] = "'$value'";
		foreach(split(",", $row['creator2']) as $key => $value)
			$creators[] = "'$value'";
		foreach(split(",", $row['creator3']) as $key => $value)
			$creators[] = "'$value'";
		foreach(split(",", $row['creator4']) as $key => $value)
			$creators[] = "'$value'";
		foreach(split(",", $row['creator5']) as $key => $value)
			$creators[] = "'$value'";
		$creators = array_unique($creators);
		if(!isset($creators))
			return FALSE;
		$condition = $this->db->formatField('id') . "=" . join(" OR " .
			$this->db->formatField('id') . "=", $creators);
		$recordset = $this->db->select(array('WKX_creator'), array("id", "surname", "prefix"), 
			" WHERE " . $condition . " ORDER BY " . $this->db->formatField('surname'));
		while($line = $this->db->loopRecordSet($recordset))
		{
			if($line['prefix'])
				$name = $line['prefix'] . ' ' . $line['surname'];
			else
				$name = $line['surname'];
			$cArray[$line['id']] = stripslashes($name);
		}
		$title = $this->messages->text("creators", "creators");
		$pString = '';
		if(isset($cArray))
		{
			foreach($cArray as $cId => $name)
				$newArray[] = $obj->getCreatorLink($row['resourceId'], $cId, $name);
			$pString = TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
			$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
			$pString .= TABLE::trStart();
			$pString .= TABLE::td(MISC::span($title . ": " .
				join(", ", $newArray), "small"));
			$pString .= TABLE::trEnd();
			$pString .= TABLE::tableEnd();
		}
		return $pString;
	}
// Show resource publisher
	function showPublisher($row)
	{
		include_once("core/publisher/PUBLISHER.php");
		$obj = new PUBLISHER($this->db);
		$pString = FALSE;
		if($row['publisherLocation'])
			$loc = ' (' . stripslashes($row['publisherLocation']) . ')';
		else
			$loc = FALSE;
		$name = stripslashes($row['publisherName']) . $loc;
		$title = $this->messages->text("resources", "publisher");
		$publisher = $obj->getPublisherLink($row['resourceId'], $row['publisher'], $name);
		$pString = TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		$pString .= TABLE::td(MISC::span($title . ": " . $publisher, "small"));
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		return $pString;
	}
// Show resource collection
	function showCollection($row)
	{
		include_once("core/collection/COLLECTION.php");
		$obj = new COLLECTION($this->db);
		$pString = FALSE;
		$title = $this->messages->text("resources", "collection");
		$collection = $obj->getCollectionLink($row['resourceId'], $row['collection'], 
			$this->html->dbToHtmlTidy(stripslashes($row['collectionTitle'])));
		$pString = TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		$pString .= TABLE::td(MISC::span($title . ": " . $collection, "small"));
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		return $pString;
	}
// Show ISBN or other identifier
	function showIsbn($row)
	{
		if(!$row['isbn'])
			return FALSE;
		$pString = $this->messages->text("resources", "isbn");
		$pString .= ":&nbsp;&nbsp;" . $this->html->dbToHtmlTidy($row['isbn']);
		return $pString;
	}
// If resource is not web_article, display any URL given
	function showUrl($row)
	{
		if(($row['type'] == 'web_article') || !$row['url'])
			return FALSE;
		include_once("core/html/FORMMISC.php");
		$fm = new FORMMISC();
		$pString = $this->messages->text("viewResource", "url");
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		$displayedUrl = $fm->reduceLongText($this->html->dbToHtmlTidy($row['url']), 80);
		$pString .= TABLE::td(MISC::a("link", $displayedUrl,
			$this->html->dbToHtmlTidy($row['url']), "_new"), "alternate1");
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		return $pString;
	}
// Error handling
	function badInput($error)
	{
		include_once("core/html/CLOSE.php");
		include_once("core/template/TEMPLATE.php");
		$template = new TEMPLATE('content');
		$template->setVar('heading', $this->messages->text("heading", "resources"));
		$template->setVar('body', $error);
		new CLOSE($this->db, $template->process());
	}
}
?>